/* Driver for routine odeint */

#include <stdio.h>
#include <math.h>
#define NRANSI
#include "nr.h"
#include "nrutil.h"
#include "decs.h"

#define NVAR 14
#define CSHWAVE 0	/* set to 1 to integrate a compressive shearing wave */
#define ISHWAVE 1	/* set to 1 to integrate an incompressive shearing wave */
#define PLUS 0		/* a value of 1 (0) chooses the positive (negative) branch of the dispersion relation */

REAL dxsav,*xp,**yp;  /* defining declarations */
int kmax,kount;
extern REAL q,kx0,ky,kz,pamp,cs,va,va0,vax,vay0,vaz,vadk,W,omega,kappa2,ombar,b,c ;
extern REAL x ;
extern int nrhs;   /* counts function evaluations */

REAL q,kx0,ky,kz,pamp,cs,va,va0,W,vax,vay0,vaz,vadk,omega,kappa2,ombar,b,c ;
REAL x ;
int nrhs;

int main(argc,argv)
int argc ;
char *argv[] ;
{
	int i,nbad,nok;
	REAL eps,h1=2.9e-4,hmin=0.0,x1,x2,*ystart;
	FILE *vsfp,*time_file ;
	REAL Lx,Ly,Lz ;
	REAL m0,n0,p0;
	REAL kx,kdvr,kdvi,kdbr,kdbi ;
	REAL xixr,xixi,xiyr,xiyi,xizr,xizi ;
	REAL vxr,vxi,vyr,vyi,vzr,vzi,rr,ri,bxr,bxi,byr,byi,bzr,bzi,omxr,omxi,jxr,jxi,pr,pi,par,pai ;
	REAL xixra,xixia,xiyra,xiyia,xizra,xizia ;
	REAL vxra,vxia,vyra,vyia,vzra,vzia,rra,ria,bxra,bxia,byra,byia,bzra,bzia,omxra,omxia,jxra,jxia;
	REAL k0,k2,k,vay ;
	REAL Phi,Phi0,omega,ombar,omegam,omdot,dt,bxaa,omb2,om2;
	REAL action,actiona,r2,v2,b2,energy ;
	static int firstc = 1;
#if FLOAT
	ystart=vector(1,NVAR);
	xp=vector(1,10000);
	yp=matrix(1,16,1,10000);
#else
	ystart=dvector(1,NVAR);
	xp=dvector(1,10000);
	yp=dmatrix(1,16,1,10000);
#endif

	if(argc < 2) {
		fprintf(stderr,"usage: ode tf eps m0 n0 p0 vaz > data.out\n") ;
		return(0) ;
	}
#if FLOAT
	sscanf(argv[1],"%f",&x2) ;
	sscanf(argv[2],"%f",&eps) ;
	sscanf(argv[3],"%f",&m0) ;
	sscanf(argv[4],"%f",&n0) ;
	sscanf(argv[5],"%f",&p0) ;
	sscanf(argv[6],"%f",&vaz) ;
#else
	sscanf(argv[1],"%lf",&x2) ;
	sscanf(argv[2],"%lf",&eps) ;
	sscanf(argv[3],"%lf",&m0) ;
	sscanf(argv[4],"%lf",&n0) ;
	sscanf(argv[5],"%lf",&p0) ;
	sscanf(argv[6],"%lf",&vaz) ;
#endif
	x1 = 0. ;
	W = 1. ;	/* orbital frequency */
	q = 1.5 ;	/* shear parameter */
	cs = 1. ;	/* sound speed */
	kappa2 = 2.*(2. - q)*W*W ;  /* epicyclic frequency */
	pamp = 1. ;
#if ISHWAVE
	kx0 = m0*2.*M_PI/10.;	/* Lx = 10 scale heights (cs/W) */
	ky = n0*2.*M_PI/10.;	/* Ly = 1 scale height */
	kz = p0*2.*M_PI/1.;	/* Lz = 1 scale height */
	k0 = sqrt(kx0*kx0 + ky*ky + kz*kz) ;
	vax = 0. ;
	vaz *= sqrt(15./16.)*W/kz ;
	vay0 = 0. ;
	vadk = kx0*vax + ky*vay0 + kz*vaz ;
	b = kappa2*kz*kz/(k0*k0) ;
	c = 4.*W*W*vadk*vadk*kz*kz/(k0*k0) ;
#if PLUS
	omb2 = 0.5*(b + sqrt(b*b + 4.*c));
#else
	omb2 = 0.5*(b - sqrt(b*b + 4.*c));
#endif
	om2 = omb2 + vadk*vadk ;
	fprintf(stderr,"omega^2: %g, omegabar^2: %g\n",om2,omb2);
	fprintf(stderr,"vadk: %g\n",vadk);
	ombar = sqrt(fabs(omb2));
	omega = sqrt(fabs(om2));
	if(om2<0.) {
		if(omb2<0.) {
			bxi = (pamp/sqrt(2.))*vadk*ombar/sqrt(fabs(omega*(2.*omb2*k0*k0 - kappa2*kz*kz))) ;
			bxr = -bxi ;
		} else {
			bxr = (pamp/sqrt(2.))*vadk*ombar/sqrt(fabs(omega*(2.*omb2*k0*k0 - kappa2*kz*kz))) ;
			bxi = -bxr ;
		}
		vxr = (omega/vadk)*bxi ;
		vxi = -(omega/vadk)*bxr ;
		omxr = (omb2*k0*k0/(2.*W*kz*omega))*vxr ;
		omxi = (omb2*k0*k0/(2.*W*kz*omega))*vxi ;
		jxr = -(omega/vadk)*(kappa2*kz*kz/(omb2*k0*k0) - 1.)*omxi ;
		jxi = (omega/vadk)*(kappa2*kz*kz/(omb2*k0*k0) - 1.)*omxr ;
	} else {
		bxr = pamp*vadk*ombar/sqrt(fabs(omega*(2.*omb2*k0*k0 - kappa2*kz*kz))) ;
		//bxr = 1./(k0*sqrt(fabs(omega)));
		bxi = 0. ;
		vxr = -(omega/vadk)*bxr ;
		vxi = -(omega/vadk)*bxi ;
		omxr = -(omb2*k0*k0/(2.*W*kz*omega))*vxi ;
		omxi = (omb2*k0*k0/(2.*W*kz*omega))*vxr ;
		jxr = (omega/vadk)*(kappa2*kz*kz/(omb2*k0*k0) - 1.)*omxr ;
		jxi = (omega/vadk)*(kappa2*kz*kz/(omb2*k0*k0) - 1.)*omxi ;
	}
	vyr = -(kz*omxr + kx0*ky*vxr)/(ky*ky + kz*kz) ;
	vyi = -(kz*omxi + kx0*ky*vxi)/(ky*ky + kz*kz) ;
	byr = -(kz*jxr + kx0*ky*bxr)/(ky*ky + kz*kz) ;
	byi = -(kz*jxi + kx0*ky*bxi)/(ky*ky + kz*kz) ;
	if(kz==0.) { vzr = vxr ; vzi = vxi ; bzr = bxr ; bzi = bxi ; }
	else {
		vzr = -(kx0*vxr + ky*vyr)/kz ;
		vzi = -(kx0*vxi + ky*vyi)/kz ;
		bzr = -(kx0*bxr + ky*byr)/kz ;
		bzi = -(kx0*bxi + ky*byi)/kz ;
	}
	rr = -(1./(cs*cs))*(vax*bxr + vay0*byr + vaz*bzr - (2.*W/(k0*k0))*(kx0*vyi + (q - 1.)*ky*vxi)) ;
	ri = -(1./(cs*cs))*(vax*bxi + vay0*byi + vaz*bzi + (2.*W/(k0*k0))*(kx0*vyr + (q - 1.)*ky*vxr)) ;
	ystart[1] = rr ;
	ystart[2] = ri ;
	ystart[3] = vxr ;
	ystart[4] = vxi ;
	ystart[5] = vyr ;
	ystart[6] = vyi ;
	ystart[7] = vzr ;
	ystart[8] = vzi ;
	ystart[9] = bxr ;
	ystart[10] = bxi ;
	ystart[11] = byr ;
	ystart[12] = byi ;
	ystart[13] = bzr ;
	ystart[14] = bzi ;
	for(i=1;i<=14;i++) fprintf(stderr,"ystart[%d]: %g\n",i,ystart[i]*sqrt(2.));
#endif
#if CSHWAVE
	kx0 = m0*2.*M_PI/0.5;	/* Lx = Ly = Lz = 1 scale height */
	ky = n0*2.*M_PI/0.5;
	kz = p0*2.*M_PI/0.5;
	k0 = sqrt(kx0*kx0 + ky*ky + kz*kz) ;
	vax = 0.1;
	vay0 = 0.2;
	vaz = -(kx0*vax + ky*vay0)/kz ;
	vadk = kx0*vax + ky*vay0 + kz*vaz ;
	va0 = sqrt(vax*vax + vay0*vay0 + vaz*vaz);
	b = (cs*cs + va0*va0)*k0*k0 ;
	c = vadk*vadk*cs*cs*k0*k0 ;
#if PLUS
	om2 = 0.5*(b + sqrt(b*b - 4.*c));
#else
	om2 = 0.5*(b - sqrt(b*b - 4.*c));
#endif
	omb2 = om2 - vadk*vadk ;
	fprintf(stderr,"omega^2: %g, omegabar^2: %g\n",om2,omb2);
	fprintf(stderr,"vadk: %g\n",vadk);
	ombar = sqrt(fabs(omb2));
	omega = sqrt(fabs(om2));
	if(om2*om2 - vadk*vadk*cs*cs*k0*k0>=0.) {
		if(omb2>=0.) {
			pr = pamp*ombar*omega*sqrt(omega)*k0/sqrt(om2*om2 - vadk*vadk*cs*cs*k0*k0) ;
			pi = 0. ;
		} else {
			pi = pamp*ombar*omega*sqrt(omega)*k0/sqrt(om2*om2 - vadk*vadk*cs*cs*k0*k0) ;
			pr = 0. ;
		}
	} else {
		if(omb2>=0.) {
			pr = (1./sqrt(2.))*pamp*ombar*omega*sqrt(omega)*k0/sqrt(vadk*vadk*cs*cs*k0*k0 - om2*om2) ;
			pi = -pr ;
		} else {
			pr = (1./sqrt(2.))*pamp*ombar*omega*sqrt(omega)*k0/sqrt(vadk*vadk*cs*cs*k0*k0 - om2*om2) ;
			pi = pr ;
		}
	}
	rr = cs*pr/omega;
	ri = cs*pi/omega;
	vxr = ((om2*kx0/(k0*k0) - vadk*vax)/omb2)*pr ;
	vxi = ((om2*kx0/(k0*k0) - vadk*vax)/omb2)*pi ;
	vyr = ((om2*ky/(k0*k0) - vadk*vay0)/omb2)*pr ;
	vyi = ((om2*ky/(k0*k0) - vadk*vay0)/omb2)*pi ;
	vzr = ((om2*kz/(k0*k0) - vadk*vaz)/omb2)*pr ;
	vzi = ((om2*kz/(k0*k0) - vadk*vaz)/omb2)*pi ;
	bxr = (vax*pr - vadk*vxr)/omega;
	bxi = (vax*pi - vadk*vxi)/omega;
	byr = (vay0*pr - vadk*vyr)/omega;
	byi = (vay0*pi - vadk*vyi)/omega;
	bzr = (vaz*pr - vadk*vzr)/omega;
	bzi = (vaz*pi - vadk*vzi)/omega;
	ystart[1] = rr ;
	ystart[2] = ri ;
	ystart[3] = vxr ;
	ystart[4] = vxi ;
	ystart[5] = vyr ;
	ystart[6] = vyi ;
	ystart[7] = vzr ;
	ystart[8] = vzi ;
	ystart[9] = bxr ;
	ystart[10] = bxi ;
	ystart[11] = byr ;
	ystart[12] = byi ;
	ystart[13] = bzr ;
	ystart[14] = bzi ;
	for(i=1;i<=14;i++) fprintf(stderr,"ystart[%d]: %g\n",i,ystart[i]);
#endif
	vadk = vax*kx0 + vay0*ky + vaz*kz ;
	nrhs=0;
	kmax=100000;
	dxsav=(x2-x1)/50000.0;
	odeint(ystart,NVAR,x1,x2,eps,h1,hmin,&nok,&nbad,derivs,stiff);
	fprintf(stderr,"#%s %13s %3d\n","successful steps:"," ",nok);
	fprintf(stderr,"#%s %20s %3d\n","bad steps:"," ",nbad);
	fprintf(stderr,"#%s %9s %3d\n","function evaluations:"," ",nrhs);
	fprintf(stderr,"#%s %3d\n","stored intermediate values:    ",kount);
	fprintf(stderr,"#eps = %g, kx0 = %g, ky = %g, kz = %g\n",eps,kx0,ky,kz) ;
	printf("#%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n","t","action","omega","energy","rr","ri","vxr","vxi","vyr","vyi","vzr","vzi","bxr","bxi","byr","byi","bzr","bzi");
	time_file = fopen("time.dat","w") ;
	Phi = Phi0 = 0. ;
	bxaa = ombar/sqrt(fabs(omega*(2.*ombar*ombar*k0*k0 - kappa2*kz*kz))) ;
	k2 = k0*k0 ;
	vay = vay0 ;
	for (i=1;i<=kount;i++) {
		kx = kx0 + q*W*ky*xp[i] ;
		k = sqrt(kx*kx + ky*ky + kz*kz) ;
		vay = vay0 - q*W*vax*xp[i] ;
		va = sqrt(vax*vax + vay*vay + vaz*vaz);
		k2 = k*k;
#if ISHWAVE
		b = kappa2*kz*kz/(k*k);
		c = 4.*W*W*vadk*vadk*kz*kz/(k*k);
#if PLUS
		omb2 = 0.5*(b + sqrt(b*b + 4.*c));
#else
		omb2 = 0.5*(b - sqrt(b*b + 4.*c));
#endif
		om2 = omb2 + vadk*vadk ;
		ombar = sqrt(fabs(omb2));
		omegam = omega;
		omega = sqrt(fabs(om2));
		kdvr = kx*yp[3][i] + ky*yp[5][i] + kz*yp[7][i] ;
		kdvi = kx*yp[4][i] + ky*yp[6][i] + kz*yp[8][i] ;
		kdbr = kx*yp[9][i] + ky*yp[11][i] + kz*yp[13][i] ;
		kdbi = kx*yp[10][i] + ky*yp[12][i] + kz*yp[14][i] ;
		if(i==1) dt = 0.;
		else {
			dt = xp[i] - xp[i-1];
			omdot = (omega - omegam)/dt;
		}
		bxaa = pamp*vadk*ombar/sqrt(fabs(omega*(2.*omb2*k*k - kappa2*kz*kz)));
		Phi += omega*dt;
		if(om2<0.) {
			if(omb2<0.) {
				bxia = (bxaa/sqrt(2.))*exp(Phi) ;
				bxra = -bxia ;
			} else {
				bxra = (bxaa/sqrt(2.))*exp(Phi) ;
				bxia = -bxra ;
			}
			vxra = (omega/vadk)*bxia ;
			vxia = -(omega/vadk)*bxra ;
			omxra = (omb2*k*k/(2.*W*kz*omega))*vxra ;
			omxia = (omb2*k*k/(2.*W*kz*omega))*vxia ;
			jxra = -(omega/vadk)*(kappa2*kz*kz/(omb2*k*k) - 1.)*omxia ;
			jxia = (omega/vadk)*(kappa2*kz*kz/(omb2*k*k) - 1.)*omxra ;
		} else {
			bxra = bxaa*cos(Phi);
			bxia = -bxaa*sin(Phi);
			vxra = -omega*bxra/vadk;
			vxia = -omega*bxia/vadk;
			omxra = -(omb2*k*k/(2.*W*kz*vadk))*bxaa*sin(Phi);
			omxia = -(omb2*k*k/(2.*W*kz*vadk))*bxaa*cos(Phi);
			jxra = (omega/vadk)*(kappa2*kz*kz/(omb2*k*k) - 1.)*omxra;
			jxia = (omega/vadk)*(kappa2*kz*kz/(omb2*k*k) - 1.)*omxia;
		}
		xixr = yp[10][i]/vadk ;
        	xixi = -yp[9][i]/vadk ;
        	xiyr = yp[12][i]/vadk ;
        	xiyi = -yp[11][i]/vadk ;
        	xizr = yp[14][i]/vadk ;
        	xizi = -yp[13][i]/vadk ;
		xixra = bxia/vadk ;
                xixia = -bxra/vadk ;
                xiyra = byia/vadk ;
                xiyia = -byra/vadk ;
                xizra = bzia/vadk ;
                xizia = -bzra/vadk ;
		vyra = -(kz*omxra + kx*ky*vxra)/(ky*ky + kz*kz);
		vyia = -(kz*omxia + kx*ky*vxia)/(ky*ky + kz*kz);
		vzra = (ky*omxra - kx*kz*vxra)/(ky*ky + kz*kz);
		vzia = (ky*omxia - kx*kz*vxia)/(ky*ky + kz*kz);
		byra = -(kz*jxra + kx*ky*bxra)/(ky*ky + kz*kz);
		byia = -(kz*jxia + kx*ky*bxia)/(ky*ky + kz*kz);
		bzra = (ky*jxra - kx*kz*bxra)/(ky*ky + kz*kz);
		bzia = (ky*jxia - kx*kz*bxia)/(ky*ky + kz*kz);
		rra = -(1./(cs*cs))*(vax*bxra + vay*byra + vaz*bzra - (2.*W/k2)*(kx*vyia + (q - 1.)*ky*vxia)) ;
		ria = -(1./(cs*cs))*(vax*bxia + vay*byia + vaz*bzia + (2.*W/k2)*(kx*vyra + (q - 1.)*ky*vxra)) ;
		v2 = yp[3][i]*yp[3][i] + yp[4][i]*yp[4][i] + yp[5][i]*yp[5][i] + yp[6][i]*yp[6][i] + yp[7][i]*yp[7][i] + yp[8][i]*yp[8][i] ;
		b2 = yp[9][i]*yp[9][i] + yp[10][i]*yp[10][i] + yp[11][i]*yp[11][i] + yp[12][i]*yp[12][i] + yp[13][i]*yp[13][i] + yp[14][i]*yp[14][i] ;
		energy = v2 + b2 + q*W*W*(q - 2.)*(xixr*xixr + xixi*xixi) ;
		energy += -2.*q*W*(xixr*yp[5][i] + xixi*yp[6][i]) ;
		action = energy/(4.*omega) ;
		actiona = vxra*vxra + vyra*vyra + vzra*vzra + vxia*vxia + vyia*vyia + vzia*vzia ;
		actiona += bxra*bxra + byra*byra + bzra*bzra + bxia*bxia + byia*byia + bzia*bzia ;
		actiona += q*W*W*(q - 2.)*(xixra*xixra + xixia*xixia) ;
                actiona += -2.*q*W*(xixra*vyra + xixia*vyia) ;
                actiona /= 4.*omega ;
#endif
#if CSHWAVE
		b = (cs*cs + va*va)*k2 ;
		c = vadk*vadk*cs*cs*k2 ;
#if PLUS
		om2 = 0.5*(b + sqrt(b*b - 4.*c));
#else
		om2 = 0.5*(b - sqrt(b*b - 4.*c));
#endif
		omb2 = om2 - vadk*vadk ;
		ombar = sqrt(fabs(omb2));
		omega = sqrt(fabs(om2));
		kdvr = kx*yp[3][i] + ky*yp[5][i] + kz*yp[7][i] ;
		kdvi = kx*yp[4][i] + ky*yp[6][i] + kz*yp[8][i] ;
		kdbr = kx*yp[9][i] + ky*yp[11][i] + kz*yp[13][i] ;
		kdbi = kx*yp[10][i] + ky*yp[12][i] + kz*yp[14][i] ;
		if(i==1) dt = 0.;
		else {
			dt = xp[i] - xp[i-1];
			omdot = (omega - omegam)/dt;
		}
		Phi += omega*dt;
		if(om2*om2 - vadk*vadk*cs*cs*k2>=0.) {
			if(omb2>=0.) {
				par = pamp*ombar*omega*sqrt(omega)*k/sqrt(om2*om2 - vadk*vadk*cs*cs*k2);
				pai = 0.;
			} else {
				pai = pamp*ombar*omega*sqrt(omega)*k/sqrt(om2*om2 - vadk*vadk*cs*cs*k2);
				par = 0.;
			}
		} else {
			if(omb2>=0.) {
				par = (1./sqrt(2.))*pamp*ombar*omega*sqrt(omega)*k/sqrt(vadk*vadk*cs*cs*k2 - om2*om2);
				pai = -par;
			} else {
				par = (1./sqrt(2.))*pamp*ombar*omega*sqrt(omega)*k/sqrt(vadk*vadk*cs*cs*k2 - om2*om2);
				pai = par;
				if(firstc==1) {Phi0 = Phi; firstc = 0;}
			}
		}
		pr = par*cos(Phi - Phi0) + pai*sin(Phi - Phi0);
		pi = pai*cos(Phi - Phi0) - par*sin(Phi - Phi0);
		rra = cs*pr/omega;
		ria = cs*pi/omega;
		vxra = ((om2*kx/k2 - vadk*vax)/omb2)*pr ;
		vxia = ((om2*kx/k2 - vadk*vax)/omb2)*pi ;
		vyra = ((om2*ky/k2 - vadk*vay)/omb2)*pr ;
		vyia = ((om2*ky/k2 - vadk*vay)/omb2)*pi ;
		vzra = ((om2*kz/k2 - vadk*vaz)/omb2)*pr ;
		vzia = ((om2*kz/k2 - vadk*vaz)/omb2)*pi ;
		bxra = (vax*pr - vadk*vxra)/omega;
		bxia = (vax*pi - vadk*vxia)/omega;
		byra = (vay*pr - vadk*vyra)/omega;
		byia = (vay*pi - vadk*vyia)/omega;
		bzra = (vaz*pr - vadk*vzra)/omega;
		bzia = (vaz*pi - vadk*vzia)/omega;
		v2 = yp[3][i]*yp[3][i] + yp[4][i]*yp[4][i] + yp[5][i]*yp[5][i] + yp[6][i]*yp[6][i] + yp[7][i]*yp[7][i] + yp[8][i]*yp[8][i] ;
                b2 = yp[9][i]*yp[9][i] + yp[10][i]*yp[10][i] + yp[11][i]*yp[11][i] + yp[12][i]*yp[12][i] + yp[13][i]*yp[13][i] + yp[14][i]*yp[14][i] ;
		r2 = yp[1][i]*yp[1][i] + yp[2][i]*yp[2][i] ;
		energy = v2 + b2 + r2 ;
                action = energy/(4.*omega) ;
                actiona = vxra*vxra + vyra*vyra + vzra*vzra + vxia*vxia + vyia*vyia + vzia*vzia ;
                actiona += bxra*bxra + byra*byra + bzra*bzra + bxia*bxia + byia*byia + bzia*bzia ;
		actiona += rra*rra + ria*ria ;
                actiona /= 4.*omega ;
#endif
		fprintf(time_file,"%15.10g\n",xp[i]) ;
		printf("%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n",
			xp[i],fabs(action),omega,energy,yp[1][i],yp[2][i],yp[3][i],yp[4][i],yp[5][i],
			yp[6][i],yp[7][i],yp[8][i],yp[9][i],yp[10][i],yp[11][i],yp[12][i],yp[13][i],yp[14][i]);
	}
	fclose(time_file) ;
	fprintf(stderr,"%s\n","********************************************************************") ;
	fprintf(stderr,"%s\n","*******                                                      *******") ;
	fprintf(stderr,"%s\n","******* The vertical mean field for the incompressive shwave *******") ;
	fprintf(stderr,"%s\n","******* is normalized to the most unstable vertical wave no. *******") ;
	fprintf(stderr,"%s\n","*******                                                      *******") ;
	fprintf(stderr,"%s\n","********************************************************************") ;
#if FLOAT
	free_matrix(yp,1,16,1,10000);
	free_vector(xp,1,10000);
	free_vector(ystart,1,NVAR);
#else
	free_dmatrix(yp,1,16,1,10000);
	free_dvector(xp,1,10000);
	free_dvector(ystart,1,NVAR);
#endif
	return 0;
}
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software vO(1Z712,$. */
